=encoding utf8

=head1 NAME

Mail::Message::Field::AuthResults - message header field authentication result

=head1 INHERITANCE

 Mail::Message::Field::AuthResults
   is a Mail::Message::Field::Structured
   is a Mail::Message::Field::Full
   is a Mail::Message::Field
   is a Mail::Reporter

=head1 SYNOPSIS

 my $f = Mail::Message::Field->new('Authentication-Results' => '...');

 my $g = Mail::Message::Field->new('Authentication-Results');
 $g->addResult(method => 'dkim', result => 'fail');

=head1 DESCRIPTION

Mail Transfer Agents may check the authenticity of an incoming message.
They add 'Authentication-Results' headers, maybe more than one.  This
implementation is based on RFC7601.

Extends L<"DESCRIPTION" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"DESCRIPTION">.
 
=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"OVERLOADED">.
 
=over 4

=item overload: B<"">

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<0+>

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<<=>>

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<bool>

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<cmp>

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<stringification>

Inherited, see L<Mail::Message::Field::Full/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"METHODS">.
 
=head2 Constructors

Extends L<"Constructors" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Constructors">.
 
=over 4

=item $obj-E<gt>B<clone>()

Inherited, see L<Mail::Message::Field/"Constructors">

=item Mail::Message::Field::AuthResults-E<gt>B<from>($field, %options)

Inherited, see L<Mail::Message::Field::Full/"Constructors">

=item Mail::Message::Field::AuthResults-E<gt>B<new>($data)

 -Option    --Defined in                      --Default
  attributes  Mail::Message::Field::Structured  <ignored>
  charset     Mail::Message::Field::Full        undef
  datum       Mail::Message::Field::Structured  undef
  encoding    Mail::Message::Field::Full        'q'
  force       Mail::Message::Field::Full        false
  language    Mail::Message::Field::Full        undef
  log         Mail::Reporter                    'WARNINGS'
  results                                       []
  server                                        <required>
  trace       Mail::Reporter                    'WARNINGS'
  version                                       undef

=over 2

=item attributes => ATTRS

=item charset => STRING

=item datum => STRING

=item encoding => 'q'|'Q'|'b'|'B'

=item force => BOOLEAN

=item language => STRING

=item log => LEVEL

=item results => ARRAY

Each authentication method is represented by a HASH, which contains
the 'method' and 'result' keys.  Sometimes, there is a 'comment'.
Properties of form 'ptype.pname' will be there as well.

=item server => DOMAIN

Where the authentication tool ran.  This should be your local service,
otherwise you may accept spoofed headers!

=item trace => LEVEL

=item version => INTEGER

=back

=back

=head2 The field

Extends L<"The field" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"The field">.
 
=over 4

=item $obj-E<gt>B<isStructured>()

=item Mail::Message::Field::AuthResults-E<gt>B<isStructured>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<length>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<nrLines>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<print>( [$fh] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<string>( [$wrap] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<toDisclose>()

Inherited, see L<Mail::Message::Field/"The field">

=back

=head2 Access to the name

Extends L<"Access to the name" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Access to the name">.
 
=over 4

=item $obj-E<gt>B<Name>()

Inherited, see L<Mail::Message::Field/"Access to the name">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::Field/"Access to the name">

=item $obj-E<gt>B<wellformedName>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the name">

=back

=head2 Access to the body

Extends L<"Access to the body" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Access to the body">.
 
=over 4

=item $obj-E<gt>B<body>()

Inherited, see L<Mail::Message::Field/"Access to the body">

=item $obj-E<gt>B<decodedBody>(%options)

Inherited, see L<Mail::Message::Field::Full/"Access to the body">

=item $obj-E<gt>B<folded>()

Inherited, see L<Mail::Message::Field/"Access to the body">

=item $obj-E<gt>B<foldedBody>( [$body] )

Inherited, see L<Mail::Message::Field/"Access to the body">

=item $obj-E<gt>B<stripCFWS>( [STRING] )

=item Mail::Message::Field::AuthResults-E<gt>B<stripCFWS>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the body">

=item $obj-E<gt>B<unfoldedBody>( [$body, [$wrap]] )

Inherited, see L<Mail::Message::Field/"Access to the body">

=back

=head2 Access to the content

Extends L<"Access to the content" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Access to the content">.
 
=over 4

=item $obj-E<gt>B<addAttribute>(...)

Attributes are not supported here.

=item $obj-E<gt>B<addResult>(HASH|PAIRS)

Add new results to this header.  Invalid results are ignored.

=item $obj-E<gt>B<addresses>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attrPairs>()

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<attribute>( $object|<STRING, %options>|<$name,$value,%options> )

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<attributes>()

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<beautify>()

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<comment>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<createComment>(STRING, %options)

=item Mail::Message::Field::AuthResults-E<gt>B<createComment>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<createPhrase>(STRING, %options)

=item Mail::Message::Field::AuthResults-E<gt>B<createPhrase>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<results>()

Returns a LIST of result HASHes.  Each HASH at least contains keys 'method',
'method_version', and 'result'.

=item $obj-E<gt>B<server>()

The hostname which ran this authentication tool.

=item $obj-E<gt>B<study>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<toDate>( [$time] )

=item Mail::Message::Field::AuthResults-E<gt>B<toDate>( [$time] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<toInt>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<version>()

The version of the 'Authentication-Results' header, which may be different
from '1' (default) for successors of RFC7601.

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Other methods">.
 
=over 4

=item $obj-E<gt>B<dateToTimestamp>(STRING)

=item Mail::Message::Field::AuthResults-E<gt>B<dateToTimestamp>(STRING)

Inherited, see L<Mail::Message::Field/"Other methods">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Internals">.
 
=over 4

=item $obj-E<gt>B<consume>( $line | <$name,<$body|$objects>> )

Inherited, see L<Mail::Message::Field/"Internals">

=item $obj-E<gt>B<decode>(STRING, %options)

=item Mail::Message::Field::AuthResults-E<gt>B<decode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=item $obj-E<gt>B<defaultWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Internals">

=item $obj-E<gt>B<encode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=item $obj-E<gt>B<fold>( $name, $body, [$maxchars] )

=item Mail::Message::Field::AuthResults-E<gt>B<fold>( $name, $body, [$maxchars] )

Inherited, see L<Mail::Message::Field/"Internals">

=item $obj-E<gt>B<setWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Internals">

=item $obj-E<gt>B<stringifyData>(STRING|ARRAY|$objects)

Inherited, see L<Mail::Message::Field/"Internals">

=item $obj-E<gt>B<unfold>(STRING)

Inherited, see L<Mail::Message::Field/"Internals">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Parsing">.
 
=over 4

=item $obj-E<gt>B<consumeComment>(STRING)

=item Mail::Message::Field::AuthResults-E<gt>B<consumeComment>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<consumeDotAtom>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<consumePhrase>(STRING)

=item Mail::Message::Field::AuthResults-E<gt>B<consumePhrase>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<datum>( [$value] )

Inherited, see L<Mail::Message::Field::Structured/"Parsing">

=item $obj-E<gt>B<parse>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<produceBody>()

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Error handling">.
 
=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<addReport>($object)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

=item Mail::Message::Field::AuthResults-E<gt>B<defaultTrace>( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<errors>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<log>( [$level, [$strings]] )

=item Mail::Message::Field::AuthResults-E<gt>B<log>( [$level, [$strings]] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logPriority>($level)

=item Mail::Message::Field::AuthResults-E<gt>B<logPriority>($level)

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<logSettings>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<report>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<reportAll>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<trace>( [$level] )

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<warnings>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Cleanup">.
 
=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"DETAILS">.
 
=head1 DIAGNOSTICS

=over 4

=item Warning: Field content is not numerical: $content

The numeric value of a field is requested (for instance the C<Lines> or
C<Content-Length> fields should be numerical), however the data contains
weird characters.

=item Error: Field name too long (max $length), in '$name'

It is not specified in the RFCs how long a field name can be, but
at least it should be a few characters shorter than the line wrap.

=item Warning: Illegal character in charset '$charset'

The field is created with an utf8 string which only contains data from the
specified character set.  However, that character set can never be a valid
name because it contains characters which are not permitted.

=item Warning: Illegal character in field name $name

A new field is being created which does contain characters not permitted
by the RFCs.  Using this field in messages may break other e-mail clients
or transfer agents, and therefore mutulate or extinguish your message.

=item Warning: Illegal character in language '$lang'

The field is created with data which is specified to be in a certain language,
however, the name of the language cannot be valid: it contains characters
which are not permitted by the RFCs.

=item Warning: Illegal encoding '$encoding', used 'q'

The RFCs only permit base64 (C<b > or C<B >) or quoted-printable
(C<q> or C<Q>) encoding.  Other than these four options are illegal.

=item Error: No attributes for Authentication-Results

Is is not possible to add attributes to this field.

=item Error: Package $package does not implement $method.

Fatal error: the specific package (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.

=back

=head1 SEE ALSO

This module is part of Mail-Message distribution version 3.016,
built on November 27, 2024. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

Copyrights 2001-2024 by [Mark Overmeer <markov@cpan.org>]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.
See F<http://dev.perl.org/licenses/>

